import java.awt.*;
import java.awt.event.*;
import java.applet.*;
import java.awt.geom.*;
import java.math.*;
import java.awt.image.*;
import java.io.File;

public class CloseCanvas extends ScaleCanvas implements MouseListener,MouseMotionListener,KeyListener {
    Manager M;
    AffineTransform A;
    Complex SOURCE;
    Complex RIVAL;
    Color COLOR;
    ListenSquare CONTROL;
    Point JX;
    boolean PRESS;   
    Voronoi VM;
    int SELECT;
    ListenSquare TITLE;
    Color PALETTE[]=new Color[5];

     public CloseCanvas() {
	 addMouseListener(this);
	 addMouseMotionListener(this);
	 addKeyListener(this);
         SELECT=0;
	 TITLE=new ListenSquare(500,0,100,80);
	 setScales(200,200,200);
	 SOURCE=new Complex(0,0);
	 RIVAL=Octahedron.specialPoint();
	 CONTROL=new ListenSquare(0,0,599,80);
	 PRESS=false;    
	 Point JX=new Point(0,0);
	 PALETTE[2]=new Color(0,0,120);  //background
     }


   public void paint(Graphics g2) {
      Graphics2D g=(Graphics2D) g2;
      g.setRenderingHint(RenderingHints.KEY_ANTIALIASING,RenderingHints.VALUE_ANTIALIAS_ON);
      drawBG(g); 
      drawCenter(g);    
      if(M.C.CLOSE.L[1].on==1)  drawBarycentric(g);
      if(M.C.CLOSE.L[2].on==1)  drawBarrier(g);
      if(M.C.CLOSE.L[0].on==1)  drawMapConstruction(g);
      drawSource(g);
      if(M.C.CLOSE.L[3].on==1)  drawMap(g);
   }

    public void drawBG(Graphics2D g) {
	g.setColor(PALETTE[2]);
	g.fillRect(0,0,this.getWidth(),this.getHeight());
    }

    public void drawPoly(Graphics2D g,Complex[] Z,Color C) {
        PolygonWrapper P=new PolygonWrapper(Z.length,Z);
	try{P=PolygonWrapper.convexHull(P);}
	catch(Exception e) {}
	Path2D.Double gp=P.toPath();
	gp=transform(gp);
	g.setColor(C);
	g.fill(gp);
    }

    public void drawMapConstruction(Graphics2D g) {
	drawParallelogram(g);
	drawmapGuidelines(g);
	drawMapTriangle1(g);
	drawMapTriangle2(g);
    }


    /**This is the map construction*/
  public void drawParallelogram(Graphics2D g) {
     int j=SELECT;
     Complex[] Z=Triangulation.scaffold1(j,SOURCE);
     for(int i=0;i<3;++i) Z[i]=fix(Z[i]);
     Complex[] W=Triangulation.scaffold2(j,SOURCE);
     Complex[] ZW={Z[1],Z[0],W[1],W[0]};
     for(int i=0;i<4;++i) {
	 for(int h=i+1;h<4;++h) {
            Complex[] W2={ZW[i],ZW[h]};
            GraphicsHelp.draw(g,this,W2,new Color(50,100,255),2);
	 }
     }
  }


    /**This draws one of the triangles for the AFP*/
    public void drawMapTriangle1(Graphics2D g) {
	int j=SELECT;
	Complex[] Z=Triangulation.scaffold1(j,SOURCE);
	for(int i=0;i<3;++i) Z[i]=fix(Z[i]);
	Path2D.Double gp=new Path2D.Double();
	for(int i=0;i<3;++i) {
	    int j1=(i+1)%3;
	    int j2=(i+2)%3;
	    Complex[] W0={Z[j1],Z[j2]};
	    int wid=2;
	    if(M.C.DISPLAY.L[3].on==1) wid=4;
	    GraphicsHelp.draw(g,this,W0,Color.red,wid);
	}
    }

    /**This draws the other triangle for the AFP*/

    public void drawMapTriangle2(Graphics2D g) {
	int j=SELECT;
	Path2D.Double gp=new Path2D.Double(); 
        g.setStroke(new BasicStroke(1));
        Complex[] W=Triangulation.scaffold2(j,SOURCE);
	Complex[] Z={W[0],W[1],SOURCE};
	for(int i=0;i<3;++i) {
	    int j1=(i+1)%3;
	    int j2=(i+2)%3;
	    Complex[] W0={Z[j1],Z[j2]};
	    GraphicsHelp.draw(g,this,W0,Color.yellow,2);
	}
    }


    /**This draws the guidelines for defining the AFP*/

    public void drawmapGuidelines(Graphics2D g) {
	int j=SELECT;
	Path2D.Double gp=new Path2D.Double();
        Complex[] Z=Triangulation.scaffold2(j,SOURCE);
        Complex[] H=Triangulation.scaffold1(j,SOURCE);
	for(int i=0;i<3;++i) H[i]=fix(H[i]);
	Color COL=new Color(255,140,0);
	int[] list1={0,1,4,5,8,9};
	int[] list2={2,1,0,2,1,0,2,1,0,2,1,0};
	boolean test=false;
	for(int i=0;i<6;++i) if(list1[i]==j) test=true;	 
        Complex RIVAL=Octahedron.findRival(SOURCE);
	RIVAL=Octahedron.anti(RIVAL);



	if(test==true) {
	  Path2D.Double gp2=Triangulation.tri(0,new Complex(0,0));
	  Complex[][] W=Triangulation.specialSegments();
	  for(int i=6;i<9;++i) {
	     Complex s=Vector.findCross2(SOURCE,Z[j%2],W[i][0],W[i][1]);
	     Complex[] ZZ={s,SOURCE};
	     GraphicsHelp.draw(g,this,ZZ,COL,2);
	  }

	  int j2=list2[j];
	  Complex s=Vector.findCross2(RIVAL,H[1-j%2],W[j2][0],W[j2][1]);
	  Complex[] ZZ={s,RIVAL};
          GraphicsHelp.draw(g,this,ZZ,COL,2);
	}

	if(test==false) {
	  Path2D.Double gp2=Triangulation.tri(0,new Complex(0,0));
	  Complex[][] W=Triangulation.specialSegments();
	  int j2=list2[j];
	  Complex s=Vector.findCross2(SOURCE,Z[1-j%2],W[j2][0],W[j2][1]);
	  Complex[] ZZ={s,SOURCE}; 
          GraphicsHelp.draw(g,this,ZZ,COL,2);

          for(int i=6;i<9;++i) {
	     s=Vector.findCross2(RIVAL,H[j%2],W[i][0],W[i][1]);
	     Complex[] ZZZ={s,RIVAL};
             GraphicsHelp.draw(g,this,ZZZ,COL,2);
	  }

	}


    }

    public Complex fix(Complex z) {
        Complex w=Octahedron.anti(z);
	w=Complex.conjugate(w);
	w=Complex.times(w,Octahedron.cr(2));
	return(w);
    }

    public void drawSource(Graphics2D g) {
	drawPoint(g,SOURCE,Color.white,3);
    }

    public void drawMap(Graphics2D g) {
	drawPoint(g,SOURCE,Color.white,3);
	Complex RIVAL=Octahedron.findRival(SOURCE);
	RIVAL=Octahedron.anti(RIVAL);
	drawPoint(g,RIVAL,Color.yellow,3);
	Complex[] W={SOURCE,RIVAL};
	GraphicsHelp.draw(g,this,W,new Color(255,255,255),2);
    }

    public void drawPoint(Graphics2D g,Complex z,Color C,int k) {
	g.setColor(C);
	Path2D.Double gp=GraphicsHelp.makeDot(z);
	g.setStroke(new BasicStroke(k));
	gp=transform(gp);
	g.draw(gp);
	g.fill(gp);
	g.setStroke(new BasicStroke(1));
    }


    public void drawCenter(Graphics2D g) {
	Path2D.Double gp=Triangulation.tri(0,new Complex(0,0));
	gp=transform(gp);
	g.setColor(Color.black);
	g.fill(gp);
    }

    public void drawBarycentric(Graphics2D g) {
	Complex[][] W=Triangulation.specialSegments();
	for(int i=0;i<9;++i) {
            GraphicsHelp.draw(g,this,W[i],new Color(100,120,140),1);
	}
    }

    public void drawBarrier(Graphics2D g) {
	for(int k=0;k<6;++k) {
	  Complex[] Z=MapFormula.barrier(k);
	  GraphicsHelp.draw(g,this,Z,new Color(100,120,140),1);
	}

    }


    public void setSource(Point X) {
        Complex temp=unTransform(X);
	setSource(temp);
    }

    public void setSource(Complex temp) {
   	int b=Triangulation.classify(temp);
	if(b==-1) return;
	SOURCE=new Complex(temp);
	Complex RIVAL=Octahedron.findRival(SOURCE);
	RIVAL=Octahedron.anti(RIVAL);
	for(int i=0;i<12;++i) {
	    Complex[] Z=Triangulation.scaffold1(i,SOURCE);
	    for(int j=0;j<3;++j) Z[j]=fix(Z[j]);
	    double test=Complex.dist(RIVAL,Z[2]);
	    if(test<.000001) SELECT=i;
	}
    }

  public void mouseEntered(MouseEvent e) {
      requestFocus();
   }

   public void mouseClicked(MouseEvent e) { 
       MouseData J=MouseData.process(e);
       doMouseClick(J.X,J.mode);
   }

   public void mouseMoved(MouseEvent e) {
       MouseData J=MouseData.process(e);
       JX=J.X; 
       if(PRESS==true) 	doMouseDrag(JX,2);
   }


    public void doMouseClick(Point X,int mode) {
	if(mode==1) scaleUp(X,-1);
	if(mode==3) scaleUp(X,1);
	if(mode==2) {
	    setSource(X);
	    try {
		Complex temp=unTransform(X);
                M.P.setSource(temp);}
	    catch(Exception e) {}
	}
	M.repaint();
    }

    public void doMouseDrag(Point X,int mode) {
	if(mode==2) {
	    setSource(X);
            try {
		Complex temp=unTransform(X);
                M.P.setSource(temp);}
	    catch(Exception e) {}

	}
	M.repaint();
    }

    public void mouseDragged(MouseEvent e) {
        MouseData J=MouseData.process(e);
	doMouseDrag(J.X,J.mode);
    }

    public void mousePressed(MouseEvent e) {

    }

     public void mouseReleased(MouseEvent e) {}
     public void mouseExited(MouseEvent e) {}   


    public void keyTyped(KeyEvent e) {
	char ch=e.getKeyChar();
	int test=0;
	if(ch=='q') test=1;
	if(ch=='w') test=2;
	if(ch=='e') test=3;
	if(ch=='i') test=1;
	if(ch=='o') test=2;
	if(ch=='p') test=3;
	if(test>0) doMouseClick(JX,test);
	repaint();
    }
 
    public void keyPressed(KeyEvent e) {
	int test=0;
	char ch=e.getKeyChar();
	if(ch=='w') PRESS=true;
	if(ch=='o') PRESS=true;
    }
    public void keyReleased(KeyEvent e) {
	PRESS=false;
    }

}

