import java.awt.*;
import java.awt.event.*;
import java.applet.*;
import java.awt.geom.*;
import java.math.*;
import java.awt.image.*;
import java.io.File;

public class ColorCanvas extends ScaleCanvas implements MouseListener, MouseMotionListener {
    Manager M;
    ListenSquare[][] COLOR=new ListenSquare[4][8];
    public static Color[][] C={
	{Color.white,new Color(180,180,180),new Color(255,0,0),new Color(0,0,255),new Color(0,0,100),new Color(255,0,0,100),new Color(50,100,255,150),Color.black},
	{new Color(210,210,210),new Color(90,90,90), new Color(150,150,150), new Color(180,180,180), new Color(120,120,120),new Color(60,60,60),null,null},
      	{new Color(0,0,0,50),new Color(255,0,255),new Color(0,0,255),new Color(255,0,0),Color.black,new Color(180,180,180),new Color(0,0,255),new Color(255,0,0),null,null},
	{new Color(0,160,0,100),new Color(0,100,0),new Color(0,200,200),new Color(0,0,200),null,null,null,null}};
        
    SelectColor SC;
    
     public ColorCanvas() {
	 addMouseListener(this);
	 SC=new SelectColor(M,0,244,499,50);
	 for(int i=0;i<4;++i) {
	     for(int j=0;j<8;++j) {
		 COLOR[i][j]=new ListenSquare(0,0,0,0);
	     }
	 }
	 setColorButtons();
     }


    public void setColorButtons() {
	for(int i=0;i<8;++i) COLOR[0][i]=new ListenSquare(5,30+25*i,20,20);
	for(int i=0;i<6;++i) COLOR[1][i]=new ListenSquare(150,30+25*i,20,20);
	for(int i=0;i<6;++i) COLOR[2][i]=new ListenSquare(250,30+25*i,20,20);
	for(int i=0;i<6;++i) COLOR[3][i]=new ListenSquare(370,30+25*i,20,20);
    }

   public void paint(Graphics g2) {
      Graphics2D g=(Graphics2D) g2;
      g.setRenderingHint(RenderingHints.KEY_ANTIALIASING,RenderingHints.VALUE_ANTIALIAS_ON);
      drawBG(g);
      drawTriangleColors(g);
      drawVoronoiColors(g);
      drawSpiderColors(g);
      drawMapColors(g);

   }

    public void drawBG(Graphics2D g) {
        g.setColor(new Color(0,0,160));
	g.fillRect(0,0,this.getWidth(),this.getHeight());
	SC.render(g);
    }

    public void drawTriangleColors(Graphics2D g) {
        g.setFont(new Font("Helvetica",Font.PLAIN,18));
	g.drawString("basic colors",10,20);
	g.setFont(new Font("Helvetica",Font.PLAIN,14));
	String[] S={"tile fill","tile outline","bary","J curve","map","cut locus","hex triangle","Voronoi lines"};
	for(int i=0;i<8;++i) {
	      COLOR[0][i].render(g,C[0][i]);
	      g.drawString(S[i],35,45+25*i);
	}
    }

    public void drawVoronoiColors(Graphics2D g) {
        g.setFont(new Font("Helvetica",Font.PLAIN,18));
	g.drawString("Voronoi",130,20);
        g.setFont(new Font("Helvetica",Font.PLAIN,14));
	for(int i=0;i<6;++i) {
	     COLOR[1][i].render(g,C[1][i]);
	     Integer I=new Integer(i);
	     g.setColor(Color.white);
	     g.drawString(I.toString(),180,40+25*i);
	}
    }

    public void drawSpiderColors(Graphics2D g) {
        g.setFont(new Font("Helvetica",Font.PLAIN,18));
	g.drawString("Spider",250,20);
	String[] S={"disk","circle","superiors","inferiors","endpoints"};
        g.setFont(new Font("Helvetica",Font.PLAIN,14));
	for(int i=0;i<5;++i) {
	     COLOR[2][i].render(g,C[2][i]);
	     Integer I=new Integer(i);
	     g.setColor(Color.white);
	     g.drawString(S[i],280,40+25*i);
	}
    }

    

    public void drawMapColors(Graphics2D g) {
        g.setFont(new Font("Helvetica",Font.PLAIN,18));
	g.drawString("Map",370,20);
	String[] S={"parallogram","outline","guide1","guide2"};
        g.setFont(new Font("Helvetica",Font.PLAIN,14));
	for(int i=0;i<4;++i) {
	     COLOR[3][i].render(g,C[3][i]);
	     Integer I=new Integer(i);
	     g.setColor(Color.white);
	     g.drawString(S[i],400,40+25*i);
	}
    }

    
    
    public void setColors(Point X) {
	for(int i=0;i<4;++i) {
	    for(int j=0;j<8;++j) {
		if(COLOR[i][j].inside(X)==1) C[i][j]=SC.C;
	    }
	}
    }




  public void mouseEntered(MouseEvent e) {
      requestFocus();
   }

   public void mouseClicked(MouseEvent e) { 
       MouseData J=MouseData.process(e);
       SC.process(e);
       setColors(J.X);
       M.repaint();
   }
   public void mouseDragged(MouseEvent e) { 
       MouseData J=MouseData.process(e);
       SC.process(e);
       M.repaint();
   }

   public void mouseMoved(MouseEvent e) {
   }

    public void mousePressed(MouseEvent e) {

    }

     public void mouseReleased(MouseEvent e) {}
     public void mouseExited(MouseEvent e) {}   


}

