import java.awt.*;
import java.awt.event.*;
import java.awt.geom.*;
import java.math.*;
import java.awt.image.*;


public class DrawVoronoi {


    public static void main(PictureCanvas P,Graphics2D g) {
	Complex[] FUN=fundamentalDomain();
	for(int i=0;i<6;++i) {
	    Complex[] FUN2=Symmetry.symmInverse(i,FUN);
	    FUN2=Symmetry.symm(P.getTriangleChoice(),FUN2);
	    Path2D.Double gp1=GraphicsHelp.toPath(FUN2);
	    gp1=P.transform(gp1);
	    g.setColor(ColorCanvas.C[0][6]);
	    g.fill(gp1);
	    triangle(P,g);
	}
	
	Complex[] Z=new Complex[6];
	Z[0]=new Complex(P.SOURCE);
	for(int q=1;q<6;++q) {
	    Z[q]=Symmetry.symmInverse(q,Z[0]);
	}
	Z=Symmetry.symm(P.getTriangleChoice(),Z);
	
	for(int i=0;i<6;++i) {
	  PolygonWrapper X=VoronoiPolygon.cell(Z,i);
	  Path2D.Double gp1=X.toPath();
	  gp1=P.transform(gp1);
	  g.setColor(ColorCanvas.C[0][7]);
	  g.draw(gp1);
	}

    }


    public static  void triangle(PictureCanvas P,Graphics2D g) {
	for(int k=0;k<6;++k) {
	  Complex[] Z=Voronoi.candidates(P.SOURCE,k);
	  Z=Symmetry.symm(P.getTriangleChoice(),Z);
	  drawPoly(P,g,Z,ColorCanvas.C[1][k]);
	}
    }


    public static void drawPoly(PictureCanvas P,Graphics2D g,Complex[] Z,Color C) {
        PolygonWrapper X=new PolygonWrapper(Z.length,Z);
	try{X=PolygonWrapper.convexHull(X);}
	catch(Exception e) {}
	Path2D.Double gp=X.toPath();
	gp=P.transform(gp);
	g.setColor(C);
	g.fill(gp);
    }

    

    public static Complex[] fundamentalDomain() {
	Complex[] Z=new Complex[3];
	Z[0]=new Complex(0,0);
	Z[1]=new Complex(1,0);
	Z[2]=new Complex(1.0/4,Math.sqrt(3)/4);
	return Z;
    }


}


