import java.applet.Applet;
import java.awt.*;
import java.awt.event.*;
import java.applet.*;
import java.awt.geom.*;
import java.math.*;



public class GraphicsHelp {

    public static Path2D.Double makeDot(Complex z) {
	Path2D.Double gp=new Path2D.Double();
	gp.moveTo((z.x),(z.y));
	gp.lineTo((z.x),(z.y));
	return(gp);
    }

    public static Path2D.Double toSegment(Complex z1,Complex z2) {
	Complex[] Z={z1,z2};
	return toSegment(Z);
    }

    public static Path2D.Double toSegment(Complex[] Z) {
        Path2D.Double gp=new Path2D.Double();
	if(Z==null) return(gp);
	gp.moveTo((Z[0].x),(Z[0].y));
	gp.lineTo((Z[1].x),(Z[1].y));
	return(gp);
    }

    public static Path2D.Double toPath(Complex[] Z) {
        Path2D.Double gp=new Path2D.Double();
	if(Z==null) return(gp);
	for(int i=0;i<Z.length;++i) {
	    if(i==0) gp.moveTo((Z[i].x),(Z[i].y));
	    if(i!=0) gp.lineTo((Z[i].x),(Z[i].y));
	}
	gp.closePath();
	return(gp);
    }

    public static Path2D.Double toGeneralCurve(Complex[] Z) {
        Path2D.Double gp=new Path2D.Double();
	if(Z==null) return(gp);
	for(int i=0;i<Z.length;++i) {
	    if(i==0) gp.moveTo((Z[i].x),(Z[i].y));
	    if(i!=0) gp.lineTo((Z[i].x),(Z[i].y));
	}
	return(gp);
    }

    public static Path2D.Double circle(Complex z,double r) {
	Path2D.Double gp=new Path2D.Double();
	for(int i=0;i<1000;++i) {
	    double t=2*Math.PI*i/1000;
	    double c=(z.x+r*Math.cos(t));
	    double s=(z.y+r*Math.sin(t));
	    if(i==0) gp.moveTo(c,s);
	    if(i!=0) gp.lineTo(c,s);
	}
	gp.closePath();
	return(gp);
    }

    public static void fill(Graphics2D g,PictureCanvas C,Complex[] Z,Color COL) {
	Path2D.Double gp=toGeneralCurve(Z);
	gp=C.transform(gp);
	g.setColor(COL);
	g.fill(gp);
	g.setStroke(new BasicStroke(1));
    }

    public static void fill(Graphics2D g,PictureCanvas C,Complex Z,Color COL,int width) {
	Path2D.Double gp=makeDot(Z);
	gp=C.transform(gp);
	g.setColor(COL);
	g.setStroke(new BasicStroke(width));
	g.fill(gp);
	g.draw(gp);
	g.setStroke(new BasicStroke(1));
    }

    public static void draw(Graphics2D g,PictureCanvas C,Complex[] Z,Color COL,int width) {
	Path2D.Double gp=toGeneralCurve(Z);
	gp=C.transform(gp);
	g.setColor(COL);
	g.setStroke(new BasicStroke(width));
	g.draw(gp);
	g.setStroke(new BasicStroke(1));
    }

    /**specially for line segments*/
    public static void drawLine(Graphics2D g,PictureCanvas C,Complex[] Z,Color COL,int width) {
	Complex[] W=new Complex[2];
	W[0]=new Complex(100*Z[0].x-99*Z[1].x,100*Z[0].y-99*Z[1].y);
	W[1]=new Complex(100*Z[1].x-99*Z[0].x,100*Z[1].y-99*Z[0].y);
	Path2D.Double gp=toGeneralCurve(W);
	gp=C.transform(gp);
	g.setColor(COL);
	g.setStroke(new BasicStroke(width));
	g.draw(gp);
	g.setStroke(new BasicStroke(1));
    }



    

    public static void fill(Graphics2D g,CloseCanvas C,Complex[] Z,Color COL) {
	Path2D.Double gp=toGeneralCurve(Z);
	gp=C.transform(gp);
	g.setColor(COL);
	g.fill(gp);
	g.setStroke(new BasicStroke(1));
    }

    public static void draw(Graphics2D g,CloseCanvas C,Complex[] Z,Color COL,int width) {
	Path2D.Double gp=toGeneralCurve(Z);
	gp=C.transform(gp);
	g.setColor(COL);
	g.setStroke(new BasicStroke(width));
	g.draw(gp);
	g.setStroke(new BasicStroke(1));
    }


}
