import java.applet.Applet;
import java.awt.*;
import java.awt.event.*;
import java.applet.*;
import java.awt.geom.*;
import java.math.*;


public class Symmetry  {




    

    /**This rotates about the origin*/

    public static Complex[] symmInverse(int q0,Complex[] Z) {
	Complex[] W=new Complex[Z.length];
	for(int i=0;i<W.length;++i) W[i]=symmInverse(q0,Z[i]);
	return W;
    }

    public static Complex symmInverse(int q0,Complex z) {
	if(q0==0) return z;
	int[][] ALPHA={{-1,-1},{-1,1},{2,0},{-1,-1},{-1,1}};
	int[][] BETA ={{+0,4},{3,5},{9,3}, {9,1},{3,-1}};
	int[] alpha=ALPHA[q0-1];
	int[] beta=BETA[q0-1];
	Complex a=new Complex(.5*alpha[0],.5*Math.sqrt(3)*alpha[1]);
	Complex b=new Complex(.5*beta[0],.5*Math.sqrt(3)*beta[1]);
	Complex w=Complex.plus(Complex.times(a,z),b);
	return w;
    }


    /**This rotates about the origin, except when q0=3.
       Then it is a translation*/
    
    public static Complex[] symm(int q0,Complex[] Z) {
	int q=(q0+60)%6;
	if(q==0) return Z;
	for(int j=1;j<6;++j) {
	  Z=rotate(j,Z);
	  if(q==j) return Z;
	}
	return null;
    }

    public static Complex[] rotate(int q,Complex[] Z) {
	Complex[] W=new Complex[Z.length];
	for(int i=0;i<Z.length;++i) W[i]=rotate(q,Z[i]);
	return W;
    }

    public static Complex rotationPoint(int k) {
	if(k==1) return new Complex(1,Math.sqrt(3));
	if(k==2) return new Complex(-.5,Math.sqrt(3)/2);
	if(k==3) return new Complex(-2,0);
	if(k==4) return new Complex(-.5,-Math.sqrt(3)/2);
	if(k==5) return new Complex(1,-Math.sqrt(3));
	return null;
    }


    public static Complex rotate(int q,Complex Z) {
	if(q==0) return Z;
	Complex a=rotationPoint(q);
	Complex w=Complex.minus(Z,a);
	w=rotate(w);
	w=Complex.plus(w,a);
	return w;
    }

    public static Complex rotate(Complex Z) {
	Complex w=new Complex(-1.0/2,Math.sqrt(3.0)/2);
	return Complex.times(Z,w);
    }


}


